#include "Args.h"
#include <assert.h>
#include <stdio.h>
#include <fstream>
#include <iostream>

Args::Args(int argc, char *argv[]){
  nargs_ = 0;
  for(int i = 1 ; i < argc ; i++){
      string arg(argv[i]);
      if(arg[0] != '-')	{
	  argList[nargs_] = arg;
	  nargs_++;
	}
      else
	{
	  nopts_++;
	  int l = arg.length();
	  assert(l > 1);
	  string opt(1,arg[1]);
	  optList.push_back(opt);
	  if(l == 2)
	  	optList.push_back("");
	  else
	    {
	      string v(arg,2,l-2);
	      optList.push_back(v);
	    }
	}
    }
}

bool
Args::isset(char c)
{
  string sig = "";
  sig += c;
  list<string>::iterator
    oIter = find(optList.begin(), optList.end(), sig);
  bool found = (oIter != optList.end());
  return found;
}


string
Args::
value(char c)
{
  string sig;
  sig += c;

  list<string>::iterator oIter = find(optList.begin(), optList.end(), sig);
  bool found = (oIter != optList.end());
  if(!found)
    {
      cerr << "Looking for value of on-line argument " << sig << endl;
	}
  ++oIter;
  return *oIter;
}


